#include <iostream>
#include <vector>
#include <queue>

using namespace std;

vector<vector<int>>gr1;
vector<vector<int>>gr2;
vector<int> dist;
void bfs1(int a) {
    dist[a] = 0;
    queue<int> q;
    q.push(a);
    while (q.size() > 0) {
        int v = q.front();
        q.pop();
        for (int i = 0;i < gr1[v].size();i++) {
            if (dist[gr1[v][i]] > dist[v] + 1) {
                dist[gr1[v][i]] = dist[v] + 1;
                q.push(gr1[v][i]);
            }
        }
    }
}
void bfs2(int a) {
    dist[a] = 0;
    queue<int> w;
    w.push(a);
    while (w.size() > 0) {
        int v = w.front();
        w.pop();
        for (int i = 0;i < gr2[v].size();i++) {
            if (dist[gr2[v][i]] > dist[v] + 1) {
                dist[gr2[v][i]] = dist[v] + 1;
                w.push(gr2[v][i]);
            }
        }
    }
}

int main() {
    int n, m;
    cin >> n >> m;
    gr1.resize(n * m);
    gr2.resize(n * m);
    dist.resize(n * m, 1e9);
    vector<vector<char>> z(n, vector<char>(m - 1));
    vector<vector<char>> k(n - 1, vector<char>(m));
    for (int i = 0;i < n;i++) {
        for (int j = 0;j < m - 1;j++) {
            cin >> z[i][j];
            if (z[i][j] == 'B') {
                gr1[m * i + j + 1].push_back(m * i + j);
                gr1[m * i + j].push_back(m * i + j + 1);
            }
            else {
                gr2[m * i + j + 1].push_back(m * i + j);
                gr2[m * i + j].push_back(m * i + j + 1);
            }
        }
    }
    for (int i = 0;i < n - 1;i++) {
        for (int j = 0;j < m;j++) {
            cin >> k[i][j];
            if (k[i][j] == 'B') {
                gr1[m * i + j + 1].push_back(m * i + j);
                gr1[m * i + j].push_back(m * i + j + 1);
            }
            else {
                gr2[m * i + j + 1].push_back(m * i + j);
                gr2[m * i + j].push_back(m * i + j + 1);
            }
        }
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        bfs1(m * (a - 1) + b - 1);
        if (dist[m * (c - 1) + d - 1] != 1e9) {
            cout << 1 << '\n';
        }
        else {
            dist.clear();
            dist.resize(n * m, 1e9);
            bfs2(m * (a - 1) + b - 1);
            if (dist[m * (c - 1) + d - 1] != 1e9) {
                cout << 1 << '\n';
            }
            else {
                cout << 2 << '\n';
            }
        }
        dist.clear();
        dist.resize(n * m, 1e9);
    }
}
